;
;			-= DYE =-
;
; WARNING:
;	!!!STACK NOT ISOLATED!!!
;
;
.code
	assume ebx:PTLS
%TRET macro
	bt [ebx].Flags,TF_LOCK
	.if Carry?
		bts [ebx].Flags,TF_SPIN
		.repeat
			bt [ebx].Flags,TF_LOCK
		.until !Carry?
		btr [ebx].Flags,TF_SPIN
	.endif
	mov edi,TSTATE.Rgp.rEsp[esp]
	mov eax,TSTATE.Control.rEip[esp]
	sub edi,sizeof(IFRAME)
	mov ecx,TSTATE.Control.rCs[esp]
	mov TSTATE.Stack[esp],edi
	mov edx,TSTATE.Control.rEFlags[esp]
	assume edi:PIFRAME
	mov [edi].rEip,eax
	mov [edi].rCs,ecx
	mov [edi].rEFlags,edx
	popad
	ifdef OPT_SEG_FS
		pop fs
	endif
	pop esp	; TSTATE.Stack -> IFRAME
if OPT_DYE eq OPT_DYE_IRET
	iretd
elseif OPT_DYE eq OPT_DYE_RETF
	push IFRAME.rEFlags[esp]
	popfd
	retf 4
elseif OPT_DYE eq OPT_DYE_RETN
	push IFRAME.rEFlags[esp]
	popfd
	retn sizeof(IFRAME) - 4
else
	.break
endif
endm

GFRAME struct
rEFlags		DWORD ?
			RFRAME <>
GFRAME ends

%JRET macro
	bt [ebx].Flags,TF_LOCK
	.if Carry?
		bts [ebx].Flags,TF_SPIN
		.repeat
			bt [ebx].Flags,TF_LOCK
		.until !Carry?
		btr [ebx].Flags,TF_SPIN
	.endif
	mov edi,TSTATE.Rgp.rEsp[esp]
	mov eax,TSTATE.Control.rEip[esp]
	sub edi,sizeof(GFRAME) + DYE_GUARD_SIZE
	mov ecx,TSTATE.Control.rCs[esp]	; * Opt
	mov TSTATE.Stack[esp],edi
	mov edx,TSTATE.Control.rEFlags[esp]
	assume edi:ptr GFRAME
	mov [edi].rEip,eax
	mov [edi].rCs,ecx
	mov [edi].rEFlags,edx
	popad
	ifdef OPT_SEG_FS
		pop fs
	endif
	pop esp	; TSTATE.Stack -> JFRAME
	
	popfd
	; * fix access to < stk
	lea esp,[esp + DYE_GUARD_SIZE + sizeof(RFRAME)]
ifdef OPT_DYE_JMPF
	jmp far ptr [esp - DYE_GUARD_SIZE - sizeof(RFRAME)]
else
	jmp RFRAME.rEip[esp - DYE_GUARD_SIZE]
endif
endm

	Public TrStep
	Public TrCallback
	Public TrExit
	Public TrRet
	Public TrScall
	Public TrSint
	
.code
	include Nt\Nt.asm
	include Nt\Flt.asm
	
NtGate proc uses ebx esi edi Service:PCME, State:PTSTATE
	mov ebx,Service
	mov edi,State
	assume ebx:PCME
	assume edi:PTSTATE
	
	mov eax,[ebx].Nt.pNtid
	.if Eax
		mov ebx,[ebx].Nt.pArgs
		
		lea ecx,[ebx][-4]	; Ip'
		
;		%DBG "0x%X %s", NTID.NtName[Eax], D[Ecx]
		
		; + EBX: POINTER TO ARG'S OF SERVICE
		; + ESI: PTLS
		; + EDI: PTSTATE
		
		mov eax,NTID.Hash[eax]
		.if Eax == 45341E13H
		.endif
		.if Eax == 0AF368886H
			invoke SyContinue
		.elseif Eax == 0E5A41DF7H
			invoke SyCallbackReturn
		.elseif Eax == 060CB79D3H
			invoke SyRaiseException
		.else
			invoke SyGetFilter, Eax
			jnz Run
			Call Eax
			jmp Exit
		.endif
	.endif
Run:
	xor eax,eax
Exit:
	ret
NtGate endp

; +
; [Esp]: CM-ip
;
TrCallmap proc C
	xchg D[esp],eax
	pushfd
	push eax
	%TLSGET Eax
	xor [eax].Flags,1 shl TF_TSTEP
	xor [eax].Flags,1 shl TF_TSTEP
	bts [eax].Flags,TF_CMRET
	pop [eax].Tcm.Ip2st
	popfd
	pop eax
	jmp TrGate
TrCallmap endp

.data?
TrBuffer		PVOID 32 DUP (?)

.code
; * reload fs, detect fs change.
; +
;
xTrGate:
	%GET_CURRENT_GRAPH_ENTRY
TrGate proc C
ifdef OPT_DYE_GUARD
	lea esp,[esp - DYE_GUARD_SIZE]
endif
	; IFRAME(TSTATE.Stack:PIFRAME at return).

	pushfd
	push cs
	push eax	; +Ip'
	cld		; !DF
	
	; Space for call etc('DYE workspace').
	
	sub esp,WSTATE.Control - WSTATE.State.Stack
	
	ifdef OPT_SEG_FS
		push fs
	endif

	; RGP
	
	pushad
	
	; Fix stack ptr.

ifdef OPT_DYE_GUARD
	add TSTATE.Rgp.rEsp[esp],(sizeof(WSTATE) - sizeof(RGP)) + DYE_GUARD_SIZE
else	
	add TSTATE.Rgp.rEsp[esp],(sizeof(WSTATE) - sizeof(RGP))
endif

	; Control state(IFRAME) -> TSTATE.
	
	mov eax,WSTATE.Control.rCs[esp]
	mov ecx,WSTATE.Control.rEFlags[esp]
	mov TSTATE.Control.rCs[esp],eax
	mov TSTATE.Control.rEFlags[esp],ecx

comment '
Esp:
	TSTATE{
		RGP
		[SEG]
		Stack:PIFRAME	; Use at return.
		IFRAME
	}
	Workspace[]
Stack:
	IFRAME
RGP.rEsp:
	...
	'

	%TLSGET Esi		; STK -> TLS
	mov ebx,[esi].Env	; TLS -> UENV
	assume ebx:PUENV
	
	; Reload TEB-sel.
	
	mov eax,[ebx].FsValue
	mov Fs,eax

	; * Set TF if DYE been trapped.
	
	btr [esi].Flags,TF_TRAP
	.if Carry?
		bts TSTATE.Control.rEFlags[esp],FLAGS_TF	; *** FIX AT EXIT(delayed trap).
	.endif

	mov [esi].Tr.State,esp
	
	; (TF_DYE at valid TSTATE)
	
	bts [esi].Flags,TF_DYE

;*	btr [esi].Flags,TF_SNIP
	
	; - ESI: PTLS, EBX:PUENV -

	; TFRAME.Ip contains:
	;	o Startup Ip for first iter.
	;	o Current Ip for restack.
	;	o CM-gate Ip for CM-ret.
	;	o Next Ip for DYE-run event.
	;	o Next Ip for TLDE.
	
	mov edi,[esi].Tr.Ip
	mov TSTATE.Control.rEip[esp],edi
	
	and [esi].Tr.Batch.S1ze,0

	; If restack then go callback.
	
	btr [esi].Flags,TF_RESTACK
	jc TrCallback
	
	; ---= RETURN VIA CM =---
	
	btr [esi].Flags,TF_CMRET
	.if Carry?
		
		btr [esi].Flags,TF_RUN
		btr [esi].Flags,TF_SCALL
	
		; Calc index of CM via Ip'.
		
		mov edi,[esi].Tcm.Ip2st
		sub edi,[esi].Tcm.Map
		and edi,NOT(7)
		sub edi,8
		
		mov ecx,[esi].Tcm.Stack
		lea eax,[ecx][edi*2]	; PCME
		
		; Restore Ip' in state.
		
		mov edx,CME.Ip[eax]
		mov TSTATE.Control.rEip[esp],edx
		
		bt CME.Flags[eax],CME_NT
		.if Carry?			; Return from service.
	
			; Post-notify to user.

			bt [ebx].Flags,GF_POSTSERVICE
			.if Carry?
				push esp
				push eax
				Call [Ebx].Event.PostService
			.endif
		.endif
		
		mov ecx,[esi].Tcm.Stack

		; Cleanup entry if IDLE.
		
		.if Edi
			bt CME.Flags[ecx][edi*2][-sizeof(CME)],CME_IDLE
			.if Carry?
				sub edi,8
			.endif
			shr edi,3
		.endif
		
		; Set current CM-index.
		
		mov [esi].Tcm.Index,edi
		jmp TrCallback
	.endif

	btr [esi].Flags,TF_RUN
	.if Carry?
	
		; Avoid NPX(use Ip2st).
		
;		invoke NpxAvoid
		
		; If batch then Ip is already decoded(new accumulation).
		
		jmp TrCallback
	.endif
	
	; First of DYE-iter.

TrStep::
	mov edx,esi
	lea edi,TrBuffer
	lea esi,[edi][4]
	mov ecx,31
	rep movsd
	mov esi,edx
	
	mov edi,TSTATE.Control.rEip[esp]
	mov eax,TSTATE.Rgp.rEbp[esp]
	mov D TrBuffer[31*4],edi
	
	; Decode instruction.

	invoke DiDecode, Edi, addr [Esi].Tr.Ia
		
	; Check for spec cpu-events.
	
	mov eax,D [esi].Tr.Ia.Opcode[0]
	bt [ebx].Flags,GF_EXECUTIVE	; * for line.
	.if Carry?
		.if (Al == 0FH) && ((Ah == 01H) || (Ah == 0A2H) || (Ah == 31H))	; CPUID, RDTSC
			; (Grp7: SIDT, SGDT, SMSW)
			push esp
			push eax
			Call [Ebx].Event.Executive
		.endif
	.endif

TrBatch::
	bt [esi].Flags,TF_BATCH
	mov ecx,[esi].Tr.Ia.S1ze
	.if Carry?
		
		; End of block at noline or spec command.
		
		test [esi].Flags,(1 shl TF_SNIP) or (1 shl TF_TLDE)
		jnz TrSnip
		bt [esi].Tr.Ia.Ea.Flags,EA_NPX
		jc TrSnip
		
		bt [esi].Tr.Ia.Ea.Flags,EA_LINE
		.if Carry?
			bts [esi].Flags,TF_BATCHING
			.if !Carry?
				mov [esi].Tr.Batch.Entry,edi	; * optimize reg
			.endif
		
			mov edi,[esi].Tr.Batch.S1ze
			lea edx,[edi][ecx]
			cmp edx,DYE_BATCH_SIZE - 5
			ja TrRun
			mov [esi].Tr.Batch.S1ze,edx
			
			; Add Ip{} to buffer.
			
			mov eax,esi
			
			add edi,[esi].RwMap
			mov esi,TSTATE.Control.rEip[esp]
			add TSTATE.Control.rEip[esp],ecx	; Ip'
			rep movsb
			
			mov esi,eax
			mov edi,edx
	
			jmp TrStop
		.endif
		
		; Skip jmp_rel can not be use, need to line-fix Ip at fault in DYE-buffer.
		
	TrSnip::
		bt [esi].Flags,TF_BATCHING
		jc TrRun
	.endif

	mov edi,TSTATE.Control.rEip[esp]
	mov [esi].Tr.Batch.S1ze,ecx
	mov [esi].Tr.Batch.Entry,edi
	
TrFetch::
	
	; Translate EA to VA.

	invoke DiCalcLinear, addr [Esi].Tr
	
	bt [esi].Tr.Ia.Ea.Flags,EA_FETCH
	.if Carry?
	
		; Track DF to bottom of stack.
		
		bt [esi].Flags,TF_STACK_WATCH
		mov eax,[esi].Tr.LaX.Linear
		.if Carry?
			.if (TSTATE.Rgp.rEsp[Esp] > Eax) && (Fs:[TEB.Tib.StackLimit] <= Eax)
				push esp
				push eax
				Call [Ebx].Event.Stack
			.else
				bt [esi].Tr.Ia.Ea.Flags,EA_XY
				mov eax,[esi].Tr.LaY.Linear
				.if Carry?
					.if (TSTATE.Rgp.rEsp[Esp] > Eax) && (Fs:[TEB.Tib.StackLimit] <= Eax)
						push esp
						push eax
						Call [Ebx].Event.Stack
					.endif
				.endif
			.endif
		.endif

		bt [ebx].Flags,GF_FETCH
		.if Carry?
			push esp
			xor ecx,ecx
			bt [esi].Tr.Ia.Ea.Flags,EA_XY
			mov ecx,[esi].Tr.LaY.Linear
			mov eax,[esi].Tr.LaX.Linear
			.if !Carry?
				xor ecx,ecx
			.endif
			push ecx
			push eax
			Call [Ebx].Event.Fetch
		.endif
	.endif
	
	mov ecx,[esi].Tr.Ia.S1ze
	mov eax,esi
	mov edx,edi
		
	mov edi,[esi].RwMap
	mov esi,TSTATE.Control.rEip[esp]
	rep movsb
	
	mov esi,eax
	mov edi,edx

	bt [esi].Tr.Ia.Ea.Flags,EA_LINE
	mov ecx,[esi].Tr.Ia.S1ze
	.if Carry?
		add TSTATE.Control.rEip[esp],ecx	; Ip'
		jmp TrRun
	.endif
	
TrSym::

	invoke VmExecute, Esi
	bt [esi].Flags,TF_SCALL
	jnc TrDye
	
	; ---= SYSTEM GATE =---
	
comment '
	Route as flow, eg:
	
		1. NtContinue
			A. Return from service(failure).
			B. Load context and run.
			
			One of two CME is IDLE.
			
		2. NtCallbackReturn
			A. Return from service.
			B. Return to NT.
			
			CME for service is IDLE in case B.
		
		Use IDLE-mark for delete last CME.
		'
	
	; Get current CME.

	mov edi,[esi].Tcm.Index
	shl edi,4		; x sizeof(CME)
	add edi,[esi].Tcm.Stack
	assume edi:PCME
	
	; Cleanup entry if IDLE.
	
	.if [Esi].Tcm.Index
		bt [edi].Flags[-sizeof(CME)],CME_IDLE
		.if Carry?
			dec [esi].Tcm.Index
			sub edi,sizeof(CME)
		.endif
	.endif

	mov [edi].Flags,1 shl CME_NT
	inc [esi].Tcm.Index
	mov [esi].Tr.Service,edi

	.if Eax == VM_INT

		mov edx,TSTATE.Rgp.rEdx[esp]
		bts [edi].Flags,CME_INT
		jmp TrSint
		
	.elseif Eax == VM_SENTER
	
		; Esp' = Edx, Args: [Edx][8], Ip': KiRet
		
		mov edx,TSTATE.Rgp.rEdx[esp]
		mov TSTATE.Rgp.rEsp[esp],edx
		jmp TrScall
	.endif
	
	; VM_WOW_FJMP
	
	; Ip' = [Esp], Args: [Esp][8], Esp' = Esp + 4
		
	mov edx,TSTATE.Rgp.rEsp[esp]
TrScall::
	add edx,8
TrSint::

	; Get NTID and store to CME.
	
	mov eax,TSTATE.Rgp.rEax[esp]
	mov [edi].Nt.pArgs,edx
	and [edi].Nt.pNtid,NULL

	bt eax,12		; SERVICE_TABLE_MASK
	.if !Carry?
		and eax,SERVICE_NUMBER_MASK
		imul eax,sizeof(NTID)
		add eax,[ebx].NtList.Dump
		.if NTID.Hash[Eax]
			mov [edi].Nt.pNtid,eax
		.endif
	.else
;	%DBG "Nt(shadow) 0x%X", Eax

	.endif
	
	; Get current CM-entry.
	
	mov eax,[esi].Tcm.Index
	shl eax,3				; Index of CM.
	add eax,[esi].Tcm.Map	; Ip'
	
	bt [edi].Flags,CME_INT
	.if Carry?
	
		; T-route via CM.
		
		sub eax,2
		xchg TSTATE.Control.rEip[esp],eax
		add eax,[esi].Tr.Ia.S1ze
	.else
		; S-route via CM.

		mov ecx,TSTATE.Rgp.rEsp[esp]
		xchg D[ecx],eax
	.endif
	mov [edi].Ip,eax
	
	push esp
	push edi
	Call NtGate
	.if !Zero?
TrKiRet:
		; Store status to state.
		
		mov TSTATE.Rgp.rEax[esp],eax
		
		; Restore Ip' from CME.
		
		bt [edi].Flags,CME_INT
		mov eax,[edi].Ip
		.if !Carry?
		
			; Emulate of system-RET.
			
			add TSTATE.Rgp.rEsp[esp],sizeof(PVOID)
		.endif
		mov TSTATE.Control.rEip[esp],eax
		
		; Post-notify to user.
	
		bt [ebx].Flags,GF_POSTSERVICE
		.if Carry?
			push esp
			push edi
			Call [Ebx].Event.PostService
;			jnz *
		.endif

		; Remove service-CME.
		
		dec [esi].Tcm.Index
		jmp TrCallback
	.endif

	; Pre-notify to user.
	
	bt [ebx].Flags,GF_PRESERVICE
	.if Carry?
		push esp
		push edi
		Call [Ebx].Event.PreService
		jnz TrKiRet
	.endif

	bt [edi].Flags,CME_INT
	jc TrRet
	jmp TrRun
	
TrDye::
	.if Eax == VM_INT
		.if Ecx == 2DH	; *
	
			; Ip'(KiDebugService) = Ip''
		
			inc [esi].Tr.Batch.S1ze
		.endif
		jmp TrRun
	.endif
	
TrRestack::
	
	; If workspace less 2xIFRAME then reload state.
	
	mov eax,TSTATE.Rgp.rEsp[esp]
	sub eax,esp
	.if Eax < (sizeof(TSTATE) + 2*sizeof(IFRAME) + DYE_GUARD_SIZE)
		bts [esi].Flags,TF_RESTACK
		jmp TrRet
	.endif
	
	; Called as trap(Eip = Ip: curr, Ip2st: prev). 

TrCallback::
	bt [ebx].Flags,GF_TRACE
	mov edi,TSTATE.Control.rEip[esp]
	.if Carry?
		push esp
		Call [Ebx].Event.Trace
		jz TrExit
	.endif
	
	and [esi].Tr.Batch.S1ze,0

	btr [esi].Flags,TF_BATCHING
	jc TrBatch
	
	btr [esi].Flags,TF_TSTEP
	jc TrExit

TrStop:
	mov eax,[esi].Tr.Stack
	mov ecx,TSTATE.Control.rEip[esp]
	.if Eax
		cmp TSTATE.Rgp.rEsp[esp],eax
		jb TrExit
	.endif
	
	; Break on Ip'.
	
	cmp [esi].Tr.Break,ecx
	jne TrStep
	
TrExit::

	bt [esi].Flags,TF_BATCHING
	jc TrRun
	
	mov eax,TSTATE.Control.rEip[esp]
	
	; Load real Ip in NPX.
	
	bt [esi].Flags,GF_NPX_TOUCH
	.if !Carry?
		mov eax,[esi].Tr.Ia.NpxLastIp
		fnstenv [esi].Fstate
		mov [esi].Fstate.Ip,eax
		fldenv [esi].Fstate
	.endif
	
	bt [esi].Flags,TF_TTHUNK
	.if Carry?
		mov eax,[esi].Tr.Thunk
		mov TSTATE.Control.rEip[esp],eax
	.endif
TrEnd::
	btr [esi].Flags,TF_DYE
	jmp TrRet
	
TrRun:
	mov eax,TSTATE.Control.rEip[esp]
	mov ecx,[esi].ExMap
	
	mov ebx,esi
	assume ebx:PTLS
	
	mov [esi].Tr.Ip,eax		; Ip'
	mov TSTATE.Control.rEip[esp],ecx
	
	mov edi,[ebx].RwMap
	add edi,[esi].Tr.Batch.S1ze

	mov al,0E9H			; JMP near
	stosb
	
	mov eax,[ebx].TrDelta
	sub eax,[ebx].Tr.Batch.S1ze
	stosd
TrExe::
	bts [ebx].Flags,TF_RUN
TrRet::
ifdef OPT_DYE_GUARD
	%JRET
else
	%TRET
endif
TrGate endp