
; PUSHAD-frame.
RGP struct
rEdi		DWORD ?
rEsi		DWORD ?
rEbp		DWORD ?
rEsp		DWORD ?
rEbx		DWORD ?
rEdx		DWORD ?
rEcx		DWORD ?
rEax		DWORD ?
RGP ends
PRGP typedef ptr RGP

R_EAX	equ 0
R_ECX	equ 1
R_EDX	equ 2
R_EBX	equ 3
R_ESP	equ 4
R_EBP	equ 5
R_ESI	equ 6
R_EDI	equ 7

RFRAME struct
rEip			PVOID ?
rCs			ULONG ?
RFRAME ends
PRFRAME typedef ptr RFRAME

; IRET-frame.
IFRAME struct
			RFRAME <>
rEFlags		DWORD ?
IFRAME ends
PIFRAME typedef ptr IFRAME

; Task state.
TSTATE struct
Rgp			RGP <>
ifdef OPT_SEG_FS
	rFs		ULONG ?
endif
Stack		PIFRAME ?
Control		IFRAME <>
TSTATE ends
PTSTATE typedef ptr TSTATE

WSTATE struct
State		TSTATE <>
Workspace		BYTE DYE_STACK_SIZE DUP (?)
Control		IFRAME <>	; * or GFRAME
WSTATE ends

MODRM_MOD		equ 11000000B
MODRM_REG		equ 00111000B
MODRM_RM		equ 00000111B

SIB_SCALE		equ 11000000B
SIB_INDEX		equ 00111000B
SIB_BASE		equ 00000111B

MAX_IL		equ 15

; Ea = Base + (2^Scale)*Index + [@MRM + Disp] or R.

EA struct
Flags		ULONG ?	; EA_*
Base			ULONG ?
Index		ULONG ?
Scale		ULONG ?
Disp			ULONG ?
EA ends
PEA typedef ptr EA

; Base flags:
EA_FETCH		equ 0
EA_LINE		equ 1
EA_MODRM		equ 2
EA_BASE		equ 3
EA_INDEX		equ 4
EA_DISP8		equ 5
EA_DISP32		equ 6
EA_STR		equ 7

; Extend flags:
EA_TRAP		equ 8
EA_IMM		equ 9
EA_NPX		equ 10	; *** ?
EA_VMD		equ 11
EA_FAIL		equ 12
EA_XY		equ 13

IA struct
Ea		EA <>
Mrm		DWORD ?
S1ze		ULONG ?	; LDE()
Pfx		ULONG ?
PfxMask	DWORD ?
pOpcode	PVOID ?
Opcodes	ULONG ?	; Valid if EA_MRM.
Opcode	BYTE 4 DUP (?)
Imm		ULONG ?
NpxType	ULONG ?	; NPX_*
NpxIp	PVOID ?
NpxLastIp	PVOID ?	; Last Ip for FPU.
VmCode	ULONG ?	; VMD_*
VmData	ULONG ?
IA ends
PIA typedef ptr IA

NTID struct
Id		ULONG ?
Hash		ULONG ?
NtName	PSTR ?
NTID ends
PNTID typedef ptr NTID

; Sys service:
NT struct
pArgs	PVOID ?
pNtid	PNTID ?
NT ends
PNT typedef ptr NT

CALLMAP struct
Limit	ULONG ?
Stack	PVOID ?
Map		PVOID ?
CALLMAP ends
PCALLMAP typedef ptr CALLMAP

; Thread callmap entry.
;
; SIZE IS FIXED 16B.
;
CME struct
Flags	DWORD ?
Ip		PVOID ?	; Ip'
; Next field valid for CME_NT.
Nt		NT <>
CME ends
PCME typedef ptr CME

CME_IDLE		equ 31
CME_NT		equ 30
CME_INT		equ 29	; Int-gate.

; Thread callmap.
;
; I = TLS_ID * NL
; @Stack = CALLMAP.Stack + I * sizeof(CME)
; @Ip' = CALLMAP.Map + 8 * I
;
TCM struct
Ip2st	PVOID ?
Index	ULONG ?
Limit	ULONG ?	; ***?
Stack	PCME ?
Map		PVOID ?
TCM ends
PTCM typedef ptr TCM

; --------
OPT_DECODER_SIZE	equ 512	; fxsave

; Flags:
TF_RUN			equ 2
TF_TRAP			equ 3	; Trap: TSTATE is virtual, mb return via NtContinue.
TF_TTHUNK			equ 4	; Rollback thunk used.
TF_TBREAK			equ 5
TF_TSTEP			equ 6
TF_DYE			equ 7
TF_TLDE			equ 10	; Undef Ip length.
TF_ENTRY			equ 11
TF_READ			equ 12
TF_SCALL			equ 13
TF_SCALL_ROUTE		equ 14
TF_BREAK			equ 15
TF_RESTACK		equ 16

TF_SPIN			equ 20
TF_LOCK			equ 21
TF_CMRET			equ 22
TF_CM_IDLE		equ 23
TF_BATCH			equ 24
TF_BATCHING		equ 25
TF_SNIP			equ 26
TF_CPUID			equ 27
TF_STACK_WATCH		equ 28

TF_DBGON			equ 29

LADDR struct
Sg		ULONG ?
Sb		ULONG ?	; Base of segment.
Ea		ULONG ?	; Offset(EA).
Linear	PVOID ?	; Seg + Offset.
LADDR ends
PLADDR typedef ptr LADDR

TBATCH struct
Entry			PVOID ?
S1ze				ULONG ?
TBATCH ends

MAX_TRACE	equ 64

TR_FULL	equ 0
TR_TRACK	equ 1

CYLCE struct
Trace	PVOID MAX_TRACE DUP (?)
Ti		PVOID ?
Tu		ULONG ?
Ta		ULONG ?
Tb		ULONG ?
Tcm		TCM <>
CYLCE ends

; Trace frame.
TFRAME struct
Ip				PVOID ?	; Entry for DYE.
Ip2st			PVOID ?	; Ip'(prev).
Ice				DWORD <>	; ICE
pIce				PVOID ?	; PICE
Ia				IA <>
LaX				LADDR <>
LaY				LADDR <>
LastIp			PVOID ?	; Frame for it.
State			PTSTATE ?
Batch			TBATCH <>
Service			PCME ?
Sfc				PVOID ?	; rEbp
Cycle			CYLCE <>
; Use if TF_TBREAK.
Break			PVOID ?	; Stop trace Ip.
; Use if TF_TBREAK & TF_TTHUNK
Thunk			PVOID ?	; Rollback thunk.
Stack			PVOID ?
TFRAME ends
PTFRAME typedef ptr TFRAME

STACK_ENTRY struct
pSp			PVOID ?
pIp			PVOID ?
STACK_ENTRY ends
PSTACK_ENTRY typedef ptr STACK_ENTRY

; Sysdef in nti386.h:
;	FNSAVE_FORMAT
;	FXSAVE_FORMAT
;	FX_SAVE_AREA
;	FLOATING_SAVE_AREA
;
; Fstenv/fldenv/fsave(part).
FSTATE struct
Control		WORD ?
			WORD ?
Status		WORD ?
			WORD ?
Tag			WORD ?
			WORD ?
Ip			PVOID ?	; +12
rCs			WORD ?
Opcode		WORD ?
Dp			PVOID ?
rDs			WORD ?
			WORD ?
FSTATE ends
PFSTATE typedef ptr FSTATE

TLS struct
Flags					DWORD ?	; ~LINK_LAST
Tid						HANDLE ?
;			-
Teb						PTEB ?
Env						PVOID ?	; PUENV for fast access.
Handle					HANDLE ?	; Current thread.
TlsId					ULONG ?
ExMap					PVOID ?
RwMap					PVOID ?
Tcm						TCM <>	; Callmap.
TrDelta					ULONG ?
Tr						TFRAME <>	; Trace frame.
Fstate					FSTATE <>	; * in tframe ?
Callers					ULONG ?
Btrace					STACK_ENTRY 256 DUP (<>)
pRwBuffer					PVOID ?	; Decoder space. 
Xptr			PVOID ?
; 16B aligned.
RwBuffer					BYTE OPT_DECODER_SIZE + 16 DUP (?)
TLS ends
PTLS typedef ptr TLS

GF_DYNLDE					equ 0	; Dynamic LDE.
GF_SROUTE					equ 1	; Trace over.
GF_RWE					equ 2	; Use RWE buffer. Else use RE/RW maps.
GF_NPX_TOUCH				equ 3	; Reload NPX state for avoid disclose.
GF_AVR_IC					equ 4	; Block of icache reader.

GF_WOW					equ 5	; Wow process.
GF_YIELD					equ 6
GF_TRACE					equ 7
GF_RELOCS					equ 8	; (Out)
GF_SERVICE				equ 10

GF_ICT					equ 11

GF_FETCH					equ 12
GF_EXECUTIVE				equ 13
GF_POSTSERVICE				equ 14
GF_PRESERVICE				equ 15

GF_KISKIP					equ 16
	
RANGE struct
Base				PVOID ?
Limit			PVOID ?
RANGE ends

API struct
pZwAllocateVirtualMemory			PVOID ?
pZwProtectVirtualMemory			PVOID ?
pZwFreeVirtualMemory			PVOID ?
pZwQueryVirtualMemory			PVOID ?
pZwQueryInformationProcess		PVOID ?
pZwQueryInformationThread		PVOID ?
pZwOpenThread					PVOID ?
pZwClose						PVOID ?
pZwYieldExecution				PVOID ?
pRtlAllocateHeap				PVOID ?
pRtlFreeHeap					PVOID ?
pLdrFindEntryForAddress			PVOID ?
pRtlAddVectoredExceptionHandler	PVOID ?
pRtlRemoveVectoredExceptionHandler	PVOID ?
pRtlWalkFrameChain				PVOID ?
pZwCreateSection				PVOID ?
pZwMapViewOfSection				PVOID ?
pZwUnmapViewOfSection			PVOID ?
pKiUserApcDispatcher			PVOID ?; 8F98FFA5
pKiUserCallbackDispatcher		PVOID ?; 1D5834E3
pKiUserExceptionDispatcher		PVOID ?
Eol							ULONG ?
API ends
PAPI typedef ptr API

EV_CPUID		equ 0A2H
EV_RDTSC		equ 031H

TEVENTS struct
;Decode
Trace					PVOID ?
Fetch					PVOID ?
Service					PVOID ?
Breakpoint				PVOID ?
;Interrupt				PVOID ?
;Timing					PVOID ?
Executive					PVOID ?
PostService				PVOID ?
PreService				PVOID ?
Stack					PVOID ?

TEVENTS ends

NTDUMP struct
Dump		PVOID ?
N		ULONG ?
NTDUMP ends
PNTDUMP typedef ptr NTDUMP

GPPATCH struct
Store	PGPSTORE ?
Build	PVOID ?
GPPATCH ends
PGPPATCH typedef ptr GPPATCH

GPCB struct
Apc		GPPATCH <>
Callback	GPPATCH <>
Exception	GPPATCH <>
Thread	GPPATCH <>
GPCB ends
PGPCB typedef ptr GPCB

UENV struct
Flags					ULONG ?
NtBase					PVOID ?
NtList					NTDUMP <>
Api						API <>

; Allocator routines.
pMmAlloc					PVOID ?
pMmFree					PVOID ?
;pMmBuild					PVOID ?	; Allocator for builder.


ExBase					PVOID ?
RwBase					PVOID ?

TlsMap					DWORD 8 DUP (?)
TlsBase					PVOID ?
TlsTids					PVOID ?
CallMap					CALLMAP <>

NpxMap					BYTE 32 DUP (?)	; For fast FPU decode.

FsValue					ULONG ?	; Default TEB sel.

; VEH
VehHandle					PVOID ?
VehIp					PVOID ?

Event					TEVENTS <>

Entry					PLDR_DATA_TABLE_ENTRY ?
Image					RANGE <>
Fetch					PVOID ?

Ki						GPCB <> 

TrN						ULONG ?
UENV ends
PUENV typedef ptr UENV

ENV_OFFSET	equ (X86_PAGE_SIZE - 4)

%GETENV macro R
	assume fs:nothing
	mov R,D fs:[TEB.Peb]
	mov R,D[R + ENV_OFFSET]
	assume R:PUENV
endm

%SETENV macro Val
	assume fs:nothing
	push Val
	mov eax,D fs:[TEB.Peb]
	pop D[eax + ENV_OFFSET]
endm

%PSHEAP macro R
	assume fs:nothing
	mov R,fs:[TEB.Peb]
	mov R,PEB.ProcessHeap[R]
endm

%TLSSET macro Value
	assume fs:nothing
	push Value
	mov ecx,fs:[TEB.Tib.StackBase]
	pop D[ecx - 4]
endm

%TLSGET macro R
	assume fs:nothing
	mov R,fs:[TEB.Tib.StackBase]
	mov R,D[R - 4]
	assume R:PTLS
endm